-module(average_tests).
-export([main/0]).
-import(average,[start/0]).
-import(testing,[dotests/2,eqTest/3]).
-import(floattesting,[withinTest/3]).  % withinTest checks for approximate equality
main() -> dotests("average_tests $Revision: 1.1 $", tests()).
tests() ->
    AS = start(),
    [withinTest(compute_average(AS, [1]),"~=~",1.0),
     withinTest(compute_average(AS, [5,6,7]),"~=~",6.0),
     withinTest(compute_average(AS, [100,5,6,7]),"~=~",29.5),
     withinTest(compute_average(AS, [1.0,10.0,20.0,30.0,40.0]),"~=~",20.2),
     withinTest(compute_average(AS, [3.14,9.86,21.5,32.7,88.514]),"~=~",31.1428),
     withinTest(compute_average(AS, [100.0,100.1,100.2]),"~=~",100.1) ].
%% helper for testing, NOT for you to implement.
-spec compute_average(AS::pid(), LON::[number()]) -> number().
compute_average(AS, LON) ->
    AS ! {self(), {average, LON}},
    receive {AS, {average_is, Res}} -> Res end.
   
